
WAFileLibrary subclass: #BPTestComponentFiles
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parasol-Tests'!

!BPTestComponentFiles methodsFor: 'images' stamp: 'haerle 8/19/2014 14:55'!
testPng
	"Just a testfile"
	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 80 0 0 0 50 8 6 0 0 0 203 45 92 252 0 0 0 38 73 68 65 84 104 129 237 193 49 1 0 0 0 194 160 245 79 109 7 111 160 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 224 49 62 178 0 1 194 74 156 166 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

WAComponent subclass: #BPTestComponent
	instanceVariableNames: 'inputFieldValue receivedFile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parasol-Tests'!

!BPTestComponent methodsFor: 'accessing' stamp: 'haerle 8/19/2014 14:55'!
inputFieldValue

	^ inputFieldValue! !

!BPTestComponent methodsFor: 'accessing' stamp: 'haerle 8/19/2014 14:55'!
receiveFile: file! !

!BPTestComponent methodsFor: 'accessing' stamp: 'haerle 8/19/2014 14:55'!
receivedFile

	^ receivedFile! !

!BPTestComponent methodsFor: 'rendering' stamp: 'haerle 8/19/2014 14:55'!
renderContentOn: html

	html paragraph: 'Supercalifragilisticexpialidocious'.
	html form get; with: [
		html textInput id: 'inputField'; callback: [ :newValue | inputFieldValue := newValue ].
		html textInput name: 'secretField'; type: 'hidden'.
		html submitButton id: 'submitButton'.
	].
	html image id: 'image'; style: 'position:absolute;left:300px;top:400px'; url: (BPTestComponentFiles / #testPng).
	html div id: 'testDiv1'; with: [
		html paragraph id: 'testDiv1p'; class: 'c1'.
	].
	html div id: 'testDiv2'; with: [
		html paragraph id: 'testDiv2p1'; class: 'c2'.
		html paragraph id: 'testDiv2p2'; class: 'c1'.
		html paragraph id: 'testDiv2p3'; class: 'c1'.
	].
	html anchor id: 'anchor1'; with: 'A Link'.
	html anchor id: 'anchor2'; with: 'A Link'.
	html paragraph
		id: 'testParagraph';
		class: 'testclass';
		with: 'Bla bla'.
	html div
		class: 'testclass2';
		with: ''.
	html anchor
		class: 'testclass2';
		with: 'foobar'.
	html anchor
		url: 'http://en.wikipedia.org/wiki/Main_Page';
		target: '_blank';
		with: 'Wikipedia'.
	html form multipart; with: [
		html fileUpload callback: [ :value | receivedFile := value ].
		html submitButton id: 'sendFile'; with: 'Send File'
	].! !

BPWebDriverTestCaseSeaside subclass: #BPMiscTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parasol-Tests'!

!BPMiscTestCase methodsFor: 'misc.' stamp: 'haerle 8/19/2014 14:55'!
componentClass

	^ BPTestComponent! !

!BPMiscTestCase methodsFor: 'testing' stamp: 'haerle 8/19/2014 14:55'!
testFileUpload

	| fileupload filesubmit file |
	
	file := BPPlatform current fileWrite: 'Test.data' contents: 'Hello World!!'.

	[
		fileupload := driver findElementByXPath: ('//input[@type=''file'']').
		filesubmit := driver findElementByID: 'sendFile'.
		fileupload sendKeys: file.
		filesubmit click.
	
		self assert: (self componentUnderTest receivedFile contentsDecodedUsing: 'UTF-8') = 'Hello World!!'.
	] ensure: [  BPPlatform current fileDelete: file].! !

BPWebDriverTestCaseSeaside subclass: #BPRemoteWebDriverTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parasol-Tests'!

!BPRemoteWebDriverTestCase class methodsFor: 'accessing' stamp: 'haerle 8/19/2014 14:55'!
packageNamesUnderTest

	^ #('NextPlan-SeleniumTests-Common')! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'haerle 8/19/2014 14:55'!
componentClass

	^ BPTestComponent! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'haerle 8/19/2014 14:55'!
configureTestApp: testApp

	testApp addLibrary: BPTestComponentFiles! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'haerle 8/19/2014 14:55'!
testClose

	self shouldnt: [ driver close ] raise: BPUnknownServerException.
	self waitForDriverToFinishClosing.
	self should: [ driver close ] raise: BPUnknownServerException.! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'haerle 8/19/2014 14:55'!
testExecuteWith

	| inputField |
	self assert: (driver executeScript: '' with: #()) isNil.
	self assert: (driver executeScript: 'return 42' with: #()) = 42.
	self assert: (driver executeScript: 'return arguments[arguments[0]]' with: #(0)) = 0.
	self assert: (driver executeScript: 'return arguments[arguments[0]]' with: #(1 42)) = 42.
	
	inputField := driver findElementByID: 'inputField'.
	self assert: (driver executeScript: 'return arguments[0].getAttribute(''type'')' with: (Array with: inputField)) = 'text'.! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'haerle 8/19/2014 14:55'!
testFindElementByCSSSelector

	| exceptionThrown |
	self assert: (driver findElementByCSSSelector: '#testDiv2 :nth-child(3)') = (driver findElementByID: 'testDiv2p3').
	exceptionThrown := false.
	"There seems to be an inconsistency between different versions of Selenium and/or different browsers, so two different exceptions might be thrown:"
	[[ driver findElementByCSSSelector: '#testDiv2 :nth-ch' ]
		on: BPInvalidSelectorException
		do: [ :ex | exceptionThrown := true. ]]
		on: BPUnknownServerException
		do: [ :ex | exceptionThrown := true. ].
	self assert: exceptionThrown.! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'haerle 8/19/2014 14:55'!
testFindElementByClassName

	self assert: (driver findElementByClassName: 'testclass') = (driver findElementByID: 'testParagraph').
	self should: [ driver findElementByClassName: 'inexistantclass' ] raise: BPNoSuchElementException.! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'haerle 8/19/2014 14:55'!
testFindElementByID

	self shouldnt: [ driver findElementByID: 'inputField' ] raise: BPNoSuchElementException.
	self should: [ driver findElementByID: 'elementThatDoesNotExist' ] raise: BPNoSuchElementException.! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'haerle 8/19/2014 14:55'!
testFindElementByLinkText

	self assert: (driver findElementByLinkText: 'A Link') = (driver findElementByID: 'anchor1').
	self deny: (driver findElementByLinkText: 'A Link') = (driver findElementByID: 'anchor2').
	
	self should: [ driver findElementByLinkText: 'Link' ] raise: BPNoSuchElementException.! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'haerle 8/19/2014 14:55'!
testFindElementByName

	self shouldnt: [ driver findElementByName: 'secretField' ] raise: BPNoSuchElementException.
	self should: [ driver findElementByName: 'elementThatDoesNotExist' ] raise: BPNoSuchElementException.
	self flag: 'Expand this test to check what happens when there are multiple elements with the same name.'.! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'haerle 8/19/2014 14:55'!
testFindElementByPartialLinkText

	self assert: (driver findElementByPartialLinkText: 'Link') = (driver findElementByID: 'anchor1').
	self deny: (driver findElementByPartialLinkText: 'Link') = (driver findElementByID: 'anchor2').
	
	self should: [ driver findElementByPartialLinkText: 'Lxnk' ] raise: BPNoSuchElementException.! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'haerle 8/19/2014 14:55'!
testFindElementByTagName

	self assert: (driver findElementByTagName: 'input') = (driver findElementByID: 'inputField').
	self should: [ driver findElementByTagName: 'tagThatIsNeverUsed' ] raise: BPNoSuchElementException.! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'haerle 8/19/2014 14:55'!
testFindElementByXPath

	self assert: (driver findElementByXPath: '//div[@id=''testDiv1'']') = (driver findElementByID: 'testDiv1').
	self assert: (driver findElementByXPath: '//div[@id=''testDiv2'']') = (driver findElementByID: 'testDiv2').
	self should: [ driver findElementByXPath: '//div[@id=' ] raise: BPInvalidSelectorException.! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'haerle 8/19/2014 14:55'!
testFindElementsByClassName

	self assert: (driver findElementsByClassName: 'testclass2') size = 2.! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'haerle 8/19/2014 14:55'!
testFindElementsByPartialLinkTest

	self flag: 'Write this test'.! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'haerle 8/19/2014 14:55'!
testFindElementsByXPath

	self flag: 'Write this test.'.! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'haerle 8/19/2014 14:55'!
testGetPageSource

	self assert: (driver getPageSource findString: 'Supercalifragilisticexpialidocious') > 0.
	driver close.
	self waitForDriverToFinishClosing.
	self should: [ driver getPageSource ] raise: BPUnknownServerException.! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'haerle 8/19/2014 14:55'!
testGetScreenshotAsByteArray

	|  form screenshotByteArray |

	screenshotByteArray := driver getScreenshotAsByteArray.
	form := BPPlatform current pngImageFromByteArray: screenshotByteArray.
	self assert: form width > 0.
	self assert: form height > 0.! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'haerle 8/19/2014 14:55'!
testGetWindowHandle

	self assert: (driver getWindowHandle) isEmpty not.! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'haerle 8/19/2014 14:55'!
testGetWindowHandles

	self assert: (driver getWindowHandles) = (Array with: driver getWindowHandle).! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'haerle 8/19/2014 14:55'!
testImplicitWait

	self flag: 'Write this test'.! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'haerle 8/19/2014 14:55'!
testSwitchTo

	| windowHandle1 windowHandle2 |

	windowHandle1 := driver getWindowHandle.
	self assert: driver getTitle = 'Seaside'.
	self assert: driver getWindowHandles = (Array with: windowHandle1).

	(driver findElementByPartialLinkText: 'Wikipedia') click.
	self assert: driver getWindowHandle = windowHandle1.
	self assert: driver getTitle = 'Seaside'.
	self assert: driver getWindowHandles size = 2.

	windowHandle2 := (driver getWindowHandles copyWithout: windowHandle1) first.
	driver switchTo window: windowHandle2.
	self assert: driver getWindowHandle = windowHandle2.
	self assert: (driver getTitle beginsWith: 'Wikipedia').! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'haerle 8/19/2014 14:55'!
testTakeScreenshot

	| filename |
	filename := self takeScreenshot.! !

!BPRemoteWebDriverTestCase methodsFor: 'misc' stamp: 'haerle 8/19/2014 14:55'!
waitForDriverToFinishClosing

	self flag: 'Check whether there is a better way to do this rather than just waiting for a set amount of time'.
	(Delay forSeconds: 1) wait.! !

BPWebDriverTestCaseSeaside subclass: #BPWebElementTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parasol-Tests'!

!BPWebElementTestCase class methodsFor: 'instance creation' stamp: 'haerle 8/19/2014 14:55'!
new
	"Answer a newly created and initialized instance."

	^super new initialize! !

!BPWebElementTestCase methodsFor: 'running' stamp: 'haerle 8/19/2014 14:55'!
componentClass

	^ BPTestComponent! !

!BPWebElementTestCase methodsFor: 'running' stamp: 'haerle 8/19/2014 14:55'!
testClear

	| inputField submitButton secretField |
	inputField := driver findElementByID: 'inputField'.
	submitButton := driver findElementByID: 'submitButton'.

	inputField sendKeys: 'XYZ'.
	inputField clear.
	inputField sendKeys: 'ABC'.
	inputField sendKeys: 'DEF'.
	submitButton click.
	self assert: self componentUnderTest inputFieldValue = 'ABCDEF'.

	self should: [ inputField clear ] raise: BPStaleElementReferenceException.

	driver get: self baseURL asString.
	secretField := driver findElementByName: 'secretField'.
	self should: [ secretField clear ] raise: BPElementNotVisibleException.! !

!BPWebElementTestCase methodsFor: 'running' stamp: 'haerle 8/19/2014 14:55'!
testClearShouldClearFieldThatWasJustFilled

	| inputField |
	inputField := driver findElementByID: 'inputField'.
	inputField sendKeys: 'XYZ'.
	inputField clear.
	
	self assert: inputField getText = ''! !

!BPWebElementTestCase methodsFor: 'running' stamp: 'haerle 8/19/2014 14:55'!
testEquals

	| testDiv1 testDiv1p testDiv1pByID testDiv1pByClassName testDiv2 |
	
	testDiv1 := driver findElementByID: 'testDiv1'.
	testDiv2 := driver findElementByID: 'testDiv2'.
	testDiv1pByID := driver findElementByID: 'testDiv1p'.
	testDiv1pByClassName := testDiv1 findElementByClassName: 'c1'.

	self flag: 'testDiv1pByID and testDiv1pByClassName do seem to have the same elementID; would be nice to expand this test with a case where the two elementIDs are not the same while still referring to the same element.'.
	self assert: testDiv1pByID = testDiv1pByClassName.
	self deny: testDiv1 = testDiv2.
	
	driver get: self baseURL asString.
	self flag: 'Should this not throw a stale element reference exception??'.
	self assert: testDiv1pByID = testDiv1pByClassName.! !

!BPWebElementTestCase methodsFor: 'running' stamp: 'haerle 8/19/2014 14:55'!
testFindElementByClassName

	| testDiv1 testDiv2 testDiv1p testDiv2p1 testDiv2p2 testDiv2p3 |
	testDiv1 := driver findElementByID: 'testDiv1'.
	testDiv2 := driver findElementByID: 'testDiv2'.

	testDiv1p := driver findElementByID: 'testDiv1p'.
	testDiv2p1 := driver findElementByID: 'testDiv2p1'.
	testDiv2p2 := driver findElementByID: 'testDiv2p2'.
	testDiv2p3 := driver findElementByID: 'testDiv2p3'.
	
	self assert: (testDiv1p getAttribute: 'class') = 'c1'.
	self assert: (testDiv2p1 getAttribute: 'class') = 'c2'.
	self assert: (testDiv2p2 getAttribute: 'class') = 'c1'.
	self assert: (testDiv2p3 getAttribute: 'class') = 'c1'.
	
	self assert: ((testDiv1 findElementByClassName: 'c1') getAttribute: 'id') = 'testDiv1p'.
	self assert: ((testDiv2 findElementByClassName: 'c1') getAttribute: 'id') = 'testDiv2p2'.
	self assert: ((testDiv2 findElementByClassName: 'c2') getAttribute: 'id') = 'testDiv2p1'.
	
	self should: [ testDiv1 findElementByClassName: 'unusedClassName' ] raise: BPNoSuchElementException.! !

!BPWebElementTestCase methodsFor: 'running' stamp: 'haerle 8/19/2014 14:55'!
testFindElementByTagName

	self flag: 'Write this test'.! !

!BPWebElementTestCase methodsFor: 'running' stamp: 'haerle 8/19/2014 14:55'!
testFindElementsByClassName

	self flag: 'Write this test'.! !

!BPWebElementTestCase methodsFor: 'running' stamp: 'haerle 8/19/2014 14:55'!
testFindElementsByPartialLinkTest

	self flag: 'Write this test'.! !

!BPWebElementTestCase methodsFor: 'running' stamp: 'haerle 8/19/2014 14:55'!
testFindElementsByTagName

	self flag: 'Write this test'.! !

!BPWebElementTestCase methodsFor: 'running' stamp: 'haerle 8/19/2014 14:55'!
testGetAttribute

	| inputField |
	inputField := driver findElementByID: 'inputField'.
	self assert: (inputField getAttribute: 'type') = 'text'.
	self assert: (inputField getAttribute: 'id') = 'inputField'.
	self assert: (inputField getAttribute: 'attributeThatIsNotSpecified') isNil.! !

!BPWebElementTestCase methodsFor: 'running' stamp: 'haerle 8/19/2014 14:55'!
testGetLocation

	| imageElement |
	imageElement := driver findElementByID: 'image'.
	self assert: (imageElement getLocation) =  (300@400).! !

!BPWebElementTestCase methodsFor: 'running' stamp: 'haerle 8/19/2014 14:55'!
testGetSize

	| imageElement |
	imageElement := driver findElementByID: 'image'.
	self assert: (imageElement getSize) = (80@50).! !

!BPWebElementTestCase methodsFor: 'running' stamp: 'haerle 8/19/2014 14:55'!
testGetText

	| paragraphElement |
	paragraphElement := driver findElementByTagName: 'p'.
	self assert: paragraphElement getText = 'Supercalifragilisticexpialidocious'.! !

!BPWebElementTestCase methodsFor: 'running' stamp: 'haerle 8/19/2014 14:55'!
testIsDisplayed

	| inputField secretField |
	inputField := driver findElementByID: 'inputField'.
	secretField := driver findElementByName: 'secretField'.
	self assert: inputField isDisplayed.
	self deny: secretField isDisplayed.! !

!BPWebElementTestCase methodsFor: 'running' stamp: 'haerle 8/19/2014 14:55'!
testSendKeys

	| inputElement submitButton |
	self assert: self componentUnderTest inputFieldValue isNil.
	inputElement := driver findElementByID: 'inputField'.
	inputElement sendKeys: 'XYZ'.
	submitButton := driver findElementByID: 'submitButton'.
	submitButton click.
	self assert: self componentUnderTest inputFieldValue = 'XYZ'.

	driver get: self baseURL asString.
	self assert: self componentUnderTest inputFieldValue isNil.
	self should: [ inputElement sendKeys: 'XYZ' ] raise: BPStaleElementReferenceException.! !

!BPWebElementTestCase methodsFor: 'running' stamp: 'haerle 8/20/2014 10:23'!
testWikipediaIsPresent
	driver get: self baseURL.
	driver findElementByLinkText: 'Wikipedia'.! !

BPWebDriverTestCaseSeaside subclass: #BPWindowTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parasol-Tests'!

!BPWindowTestCase methodsFor: 'running' stamp: 'haerle 8/19/2014 14:55'!
componentClass

	^ BPTestComponent! !

!BPWindowTestCase methodsFor: 'running' stamp: 'haerle 8/19/2014 14:55'!
testPosition

	| window1 windowHandle1 windowHandle2 window2 |
	
	window1 := driver manage window.
	window1 setPosition: 25@30.
	self assert: window1 getPosition = (25@30).
	
	windowHandle1 := driver getWindowHandle.
	(driver findElementByPartialLinkText: 'Wikipedia') click.
	windowHandle2 := (driver getWindowHandles copyWithout: windowHandle1) first.
	driver switchTo window: windowHandle2.

	self flag: 'The following does not work, need to figure out why not'.
"	window2 := driver manage window.
	
	window1 setPosition: 52@66.
	window2 setPosition: 63@74.
	self assert: window1 getPosition = (52@66).
	self assert: window2 getPosition = (63@74)."! !

!BPWindowTestCase methodsFor: 'running' stamp: 'haerle 8/19/2014 14:55'!
testSize

	| window1 windowHandle1 windowHandle2 window2 |
	
	window1 := driver manage window.
	window1 setSize: 400@250.
	self assert: window1 getSize = (400@250).
	
	windowHandle1 := driver getWindowHandle.
	(driver findElementByPartialLinkText: 'Wikipedia') click.
	windowHandle2 := (driver getWindowHandles copyWithout: windowHandle1) first.
	driver switchTo window: windowHandle2.

	self flag: 'The following does not work, need to figure out why not'.
"	window2 := driver manage window.
	
	window1 setSize: 210@300.
	window2 setSize: 255@290.
	self assert: window1 getSize = (210@300).
	self assert: window2 getSize = (255@290)."! !

TestCase subclass: #BPPlatformTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parasol-Tests'!

!BPPlatformTest methodsFor: 'tests' stamp: 'haerle 8/20/2014 09:27'!
testJsonWebElement

	| json object |
	object := BPWebElement driver: nil elementID: 42.
	json := BPPlatform current jsonWrite: object.
	self assert: (json select: [:c | c ~=$ ]) = '{"ELEMENT":42}'.! !

!BPPlatformTest methodsFor: 'tests' stamp: 'haerle 8/20/2014 09:27'!
testParseStatusFromJson

	| json status parsed |
	json := '{"sessionId":"1350900111656","status":0,"value":{"ELEMENT":"0"},"class":"org.openqa.selenium.remote.Response","hCode":1690596504}'.
	parsed := BPPlatform current jsonRead: json.
	status := parsed at: 'status'.
	self assert: 0 = status.! !

!BPPlatformTest methodsFor: 'tests' stamp: 'haerle 8/20/2014 09:27'!
testParseWebElement

	| json parsed |
	json := '{"ELEMENT":"0"}'.
	parsed := BPPlatform current jsonRead: json.
	self assert: (parsed at: 'ELEMENT') = '0'! !
